/* gcalc-function-exp.c generated by valac 0.56.17, the Vala compiler
 * generated from gcalc-function-exp.vala, do not modify */

/* gcalc-function-exp.vala
 *
 * Copyright (C) 2019  Daniel Espinosa <esodan@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Daniel Espinosa <esodan@gmail.com>
 */

#include "gcalc/gcalc.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <mpc.h>
#include <mpfr.h>
#include <gee.h>
#include "gcalc.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GCALC_FUNCTION_EXP_0_PROPERTY,
	GCALC_FUNCTION_EXP_NUM_PROPERTIES
};
static GParamSpec* gcalc_function_exp_properties[GCALC_FUNCTION_EXP_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer gcalc_function_exp_parent_class = NULL;

VALA_EXTERN GCalcMathExpression* gcalc_function_evaluate (GCalcFunction* self,
                                              GError** error);
static GCalcMathExpression* gcalc_function_exp_real_evaluate (GCalcFunction* base,
                                                       GError** error);
VALA_EXTERN void gcalc_constant_get_complex (GCalcConstant* self,
                                 __mpc_struct* result);
VALA_EXTERN GCalcConstant* gcalc_constant_new_internal_complex (__mpc_struct* complex);
VALA_EXTERN GCalcConstant* gcalc_constant_construct_internal_complex (GType object_type,
                                                          __mpc_struct* complex);
static GObject * gcalc_function_exp_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static GType gcalc_function_exp_get_type_once (void);

static gpointer
_g_object_ref0 (gpointer self)
{
#line 46 "../gcalc/gcalc-function-exp.vala"
	return self ? g_object_ref (self) : NULL;
#line 75 "gcalc-function-exp.c"
}

static GCalcMathExpression*
gcalc_function_exp_real_evaluate (GCalcFunction* base,
                                  GError** error)
{
	GCalcFunctionExp * self;
	GCalcConstant* c = NULL;
	GCalcMathExpression* exp = NULL;
	GCalcExpressionContainer* _tmp0_;
	GCalcExpressionContainer* _tmp1_;
	GObject* _tmp2_;
	GCalcMathExpression* _tmp3_;
	GCalcMathExpression* _tmp4_;
	GCalcMathResult* ev = NULL;
	GCalcMathExpression* _tmp7_;
	GCalcMathResult* _tmp8_;
	GCalcMathResult* _tmp9_;
	GCalcMathResult* _tmp14_;
	GCalcConstant* _tmp19_;
	__mpc_struct p1 = {0};
	GCalcConstant* _tmp21_;
	__mpc_struct _tmp22_ = {0};
	__mpc_struct res = {0};
	GCalcConstant* nc = NULL;
	GCalcConstant* _tmp23_;
	GCalcConstant* _tmp24_;
	GCalcMathExpression* _tmp25_;
	GError* _inner_error0_ = NULL;
	GCalcMathExpression* result;
#line 33 "../gcalc/gcalc-function-exp.vala"
	self = (GCalcFunctionExp*) base;
#line 35 "../gcalc/gcalc-function-exp.vala"
	gcalc_math_function_verify_params ((GCalcMathFunction*) self, &_inner_error0_);
#line 35 "../gcalc/gcalc-function-exp.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "../gcalc/gcalc-function-exp.vala"
		g_propagate_error (error, _inner_error0_);
#line 35 "../gcalc/gcalc-function-exp.vala"
		return NULL;
#line 116 "gcalc-function-exp.c"
	}
#line 36 "../gcalc/gcalc-function-exp.vala"
	c = NULL;
#line 37 "../gcalc/gcalc-function-exp.vala"
	_tmp0_ = gcalc_math_expression_get_expressions ((GCalcMathExpression*) self);
#line 37 "../gcalc/gcalc-function-exp.vala"
	_tmp1_ = _tmp0_;
#line 37 "../gcalc/gcalc-function-exp.vala"
	_tmp2_ = g_list_model_get_item ((GListModel*) _tmp1_, (guint) 0);
#line 37 "../gcalc/gcalc-function-exp.vala"
	_tmp3_ = GCALC_IS_MATH_EXPRESSION (_tmp2_) ? ((GCalcMathExpression*) _tmp2_) : NULL;
#line 37 "../gcalc/gcalc-function-exp.vala"
	if (_tmp3_ == NULL) {
#line 37 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (_tmp2_);
#line 132 "gcalc-function-exp.c"
	}
#line 37 "../gcalc/gcalc-function-exp.vala"
	exp = _tmp3_;
#line 38 "../gcalc/gcalc-function-exp.vala"
	_tmp4_ = exp;
#line 38 "../gcalc/gcalc-function-exp.vala"
	if (_tmp4_ == NULL) {
#line 140 "gcalc-function-exp.c"
		const gchar* _tmp5_;
		GError* _tmp6_;
#line 39 "../gcalc/gcalc-function-exp.vala"
		_tmp5_ = g_type_name (GCALC_TYPE_MATH_EXPRESSION);
#line 39 "../gcalc/gcalc-function-exp.vala"
		_tmp6_ = g_error_new (GCALC_FUNCTION_ERROR, GCALC_FUNCTION_ERROR_INVOCATION_ERROR, _ ("Invalid parameter type. Expected %s"), _tmp5_);
#line 39 "../gcalc/gcalc-function-exp.vala"
		_inner_error0_ = _tmp6_;
#line 39 "../gcalc/gcalc-function-exp.vala"
		g_propagate_error (error, _inner_error0_);
#line 39 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (exp);
#line 39 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (c);
#line 39 "../gcalc/gcalc-function-exp.vala"
		return NULL;
#line 157 "gcalc-function-exp.c"
	}
#line 41 "../gcalc/gcalc-function-exp.vala"
	_tmp7_ = exp;
#line 41 "../gcalc/gcalc-function-exp.vala"
	_tmp8_ = gcalc_math_expression_solve (_tmp7_);
#line 41 "../gcalc/gcalc-function-exp.vala"
	ev = _tmp8_;
#line 42 "../gcalc/gcalc-function-exp.vala"
	_tmp9_ = ev;
#line 42 "../gcalc/gcalc-function-exp.vala"
	if (GCALC_IS_ERROR_RESULT (_tmp9_)) {
#line 169 "gcalc-function-exp.c"
		GCalcMathResult* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		GError* _tmp13_;
#line 43 "../gcalc/gcalc-function-exp.vala"
		_tmp10_ = ev;
#line 43 "../gcalc/gcalc-function-exp.vala"
		_tmp11_ = gcalc_math_error_result_get_message ((GCalcMathErrorResult*) G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GCALC_TYPE_ERROR_RESULT, GCalcErrorResult));
#line 43 "../gcalc/gcalc-function-exp.vala"
		_tmp12_ = _tmp11_;
#line 43 "../gcalc/gcalc-function-exp.vala"
		_tmp13_ = g_error_new (GCALC_FUNCTION_ERROR, GCALC_FUNCTION_ERROR_INVOCATION_ERROR, _ ("Invalid expression: %s"), _tmp12_);
#line 43 "../gcalc/gcalc-function-exp.vala"
		_inner_error0_ = _tmp13_;
#line 43 "../gcalc/gcalc-function-exp.vala"
		g_propagate_error (error, _inner_error0_);
#line 43 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (ev);
#line 43 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (exp);
#line 43 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (c);
#line 43 "../gcalc/gcalc-function-exp.vala"
		return NULL;
#line 194 "gcalc-function-exp.c"
	}
#line 45 "../gcalc/gcalc-function-exp.vala"
	_tmp14_ = ev;
#line 45 "../gcalc/gcalc-function-exp.vala"
	if (GCALC_IS_MATH_RESULT (_tmp14_)) {
#line 200 "gcalc-function-exp.c"
		GCalcMathResult* _tmp15_;
		GCalcMathExpression* _tmp16_;
		GCalcMathExpression* _tmp17_;
		GCalcConstant* _tmp18_;
#line 46 "../gcalc/gcalc-function-exp.vala"
		_tmp15_ = ev;
#line 46 "../gcalc/gcalc-function-exp.vala"
		_tmp16_ = gcalc_math_result_get_expression (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GCALC_TYPE_MATH_RESULT, GCalcMathResult));
#line 46 "../gcalc/gcalc-function-exp.vala"
		_tmp17_ = _tmp16_;
#line 46 "../gcalc/gcalc-function-exp.vala"
		_tmp18_ = _g_object_ref0 (GCALC_IS_CONSTANT (_tmp17_) ? ((GCalcConstant*) _tmp17_) : NULL);
#line 46 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (c);
#line 46 "../gcalc/gcalc-function-exp.vala"
		c = _tmp18_;
#line 217 "gcalc-function-exp.c"
	}
#line 48 "../gcalc/gcalc-function-exp.vala"
	_tmp19_ = c;
#line 48 "../gcalc/gcalc-function-exp.vala"
	if (_tmp19_ == NULL) {
#line 223 "gcalc-function-exp.c"
		GError* _tmp20_;
#line 49 "../gcalc/gcalc-function-exp.vala"
		_tmp20_ = g_error_new_literal (GCALC_FUNCTION_ERROR, GCALC_FUNCTION_ERROR_INVOCATION_ERROR, _ ("Invalid expression in result"));
#line 49 "../gcalc/gcalc-function-exp.vala"
		_inner_error0_ = _tmp20_;
#line 49 "../gcalc/gcalc-function-exp.vala"
		g_propagate_error (error, _inner_error0_);
#line 49 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (ev);
#line 49 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (exp);
#line 49 "../gcalc/gcalc-function-exp.vala"
		_g_object_unref0 (c);
#line 49 "../gcalc/gcalc-function-exp.vala"
		return NULL;
#line 239 "gcalc-function-exp.c"
	}
#line 51 "../gcalc/gcalc-function-exp.vala"
	mpc_init2 (&p1, (mpfr_prec_t) 1000);
#line 52 "../gcalc/gcalc-function-exp.vala"
	_tmp21_ = c;
#line 52 "../gcalc/gcalc-function-exp.vala"
	gcalc_constant_get_complex (_tmp21_, &_tmp22_);
#line 52 "../gcalc/gcalc-function-exp.vala"
	mpc_set (&p1, &_tmp22_, MPC_RNDNN);
#line 53 "../gcalc/gcalc-function-exp.vala"
	mpc_init2 (&res, (mpfr_prec_t) 1000);
#line 54 "../gcalc/gcalc-function-exp.vala"
	mpc_exp (&res, &p1, MPC_RNDNN);
#line 55 "../gcalc/gcalc-function-exp.vala"
	_tmp23_ = gcalc_constant_new_internal_complex (&res);
#line 55 "../gcalc/gcalc-function-exp.vala"
	nc = _tmp23_;
#line 56 "../gcalc/gcalc-function-exp.vala"
	_tmp24_ = nc;
#line 56 "../gcalc/gcalc-function-exp.vala"
	_tmp25_ = _g_object_ref0 (GCALC_IS_MATH_EXPRESSION (_tmp24_) ? ((GCalcMathExpression*) _tmp24_) : NULL);
#line 56 "../gcalc/gcalc-function-exp.vala"
	result = _tmp25_;
#line 56 "../gcalc/gcalc-function-exp.vala"
	_g_object_unref0 (nc);
#line 56 "../gcalc/gcalc-function-exp.vala"
	mpc_clear (&res);
#line 56 "../gcalc/gcalc-function-exp.vala"
	mpc_clear (&p1);
#line 56 "../gcalc/gcalc-function-exp.vala"
	_g_object_unref0 (ev);
#line 56 "../gcalc/gcalc-function-exp.vala"
	_g_object_unref0 (exp);
#line 56 "../gcalc/gcalc-function-exp.vala"
	_g_object_unref0 (c);
#line 56 "../gcalc/gcalc-function-exp.vala"
	return result;
#line 277 "gcalc-function-exp.c"
}

GCalcFunctionExp*
gcalc_function_exp_construct (GType object_type)
{
	GCalcFunctionExp * self = NULL;
#line 25 "../gcalc/gcalc-function-exp.vala"
	self = (GCalcFunctionExp*) gcalc_function_construct (object_type);
#line 25 "../gcalc/gcalc-function-exp.vala"
	return self;
#line 288 "gcalc-function-exp.c"
}

GCalcFunctionExp*
gcalc_function_exp_new (void)
{
#line 25 "../gcalc/gcalc-function-exp.vala"
	return gcalc_function_exp_construct (GCALC_TYPE_FUNCTION_EXP);
#line 296 "gcalc-function-exp.c"
}

static GObject *
gcalc_function_exp_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GCalcFunctionExp * self;
	GCalcExpressionContainer* _tmp0_;
	GCalcExpressionContainer* _tmp1_;
	GCalcConstant* _tmp2_;
	GCalcConstant* _tmp3_;
#line 27 "../gcalc/gcalc-function-exp.vala"
	parent_class = G_OBJECT_CLASS (gcalc_function_exp_parent_class);
#line 27 "../gcalc/gcalc-function-exp.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../gcalc/gcalc-function-exp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GCALC_TYPE_FUNCTION_EXP, GCalcFunctionExp);
#line 28 "../gcalc/gcalc-function-exp.vala"
	gcalc_math_function_set_name ((GCalcMathFunction*) self, "exp");
#line 29 "../gcalc/gcalc-function-exp.vala"
	gcalc_math_function_set_n_params ((GCalcMathFunction*) self, (guint) 1);
#line 30 "../gcalc/gcalc-function-exp.vala"
	_tmp0_ = gcalc_math_function_get_param_types ((GCalcMathFunction*) self);
#line 30 "../gcalc/gcalc-function-exp.vala"
	_tmp1_ = _tmp0_;
#line 30 "../gcalc/gcalc-function-exp.vala"
	_tmp2_ = gcalc_constant_new ();
#line 30 "../gcalc/gcalc-function-exp.vala"
	_tmp3_ = _tmp2_;
#line 30 "../gcalc/gcalc-function-exp.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (GCalcMathExpression*) _tmp3_);
#line 30 "../gcalc/gcalc-function-exp.vala"
	_g_object_unref0 (_tmp3_);
#line 27 "../gcalc/gcalc-function-exp.vala"
	return obj;
#line 335 "gcalc-function-exp.c"
}

static void
gcalc_function_exp_class_init (GCalcFunctionExpClass * klass,
                               gpointer klass_data)
{
#line 25 "../gcalc/gcalc-function-exp.vala"
	gcalc_function_exp_parent_class = g_type_class_peek_parent (klass);
#line 25 "../gcalc/gcalc-function-exp.vala"
	((GCalcFunctionClass *) klass)->evaluate = (GCalcMathExpression* (*) (GCalcFunction*, GError**)) gcalc_function_exp_real_evaluate;
#line 25 "../gcalc/gcalc-function-exp.vala"
	G_OBJECT_CLASS (klass)->constructor = gcalc_function_exp_constructor;
#line 348 "gcalc-function-exp.c"
}

static void
gcalc_function_exp_instance_init (GCalcFunctionExp * self,
                                  gpointer klass)
{
}

/**
 * Function to calculate inverse of logarithm of a {@link MathConstant}
 */
static GType
gcalc_function_exp_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GCalcFunctionExpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gcalc_function_exp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GCalcFunctionExp), 0, (GInstanceInitFunc) gcalc_function_exp_instance_init, NULL };
	GType gcalc_function_exp_type_id;
	gcalc_function_exp_type_id = g_type_register_static (GCALC_TYPE_FUNCTION, "GCalcFunctionExp", &g_define_type_info, 0);
	return gcalc_function_exp_type_id;
}

GType
gcalc_function_exp_get_type (void)
{
	static volatile gsize gcalc_function_exp_type_id__once = 0;
	if (g_once_init_enter (&gcalc_function_exp_type_id__once)) {
		GType gcalc_function_exp_type_id;
		gcalc_function_exp_type_id = gcalc_function_exp_get_type_once ();
		g_once_init_leave (&gcalc_function_exp_type_id__once, gcalc_function_exp_type_id);
	}
	return gcalc_function_exp_type_id__once;
}

